import { jsx as ce } from "react/jsx-runtime";
import { useMemo as j, useState as fe, useRef as Se, useLayoutEffect as Pe, createElement as Re } from "react";
import * as te from "helper-js";
import { VirtualList as Ke } from "react-base-virtual-list";
/*!
 * he-tree-react
 * Author: phphe <phphe@outlook.com> (https://github.com/phphe)
 * Released under the MIT License.
 */
const ne = {
  id: null,
  x: 0,
  y: 0,
  time: 0
}, Ne = {
  /**
   * 
   */
  idKey: "id",
  parentIdKey: "parent_id",
  childrenKey: "children",
  indent: 20,
  dragOpen: !1,
  dragOpenDelay: 600,
  placeholderId: "__DRAG_PLACEHOLDER__",
  dataType: "flat",
  direction: "ltr",
  rootId: null,
  virtual: !1
};
function ze(r) {
  const e = { ...Ne, ...r }, { idKey: o, parentIdKey: n, childrenKey: p, placeholderId: g, isFunctionReactive: I } = e, c = { idKey: o, parentIdKey: n };
  if (!e.renderNode && !e.renderNodeBox)
    throw new Error("Either renderNodeBox or renderNode is required.");
  const d = e.direction === "rtl", l = j(() => e.openIds ? [...e.openIds].sort().toString() : void 0, [e.openIds]), D = j(() => new Set(e.openIds), [l]), C = j(() => e.checkedIds ? [...e.checkedIds].sort().toString() : "", [e.checkedIds]), P = j(() => new Set(e.checkedIds), [C]), O = j(
    () => {
      var le, ae;
      const E = {}, _ = {}, B = [], z = [], V = [], J = [];
      function* se() {
        if (e.dataType === "flat")
          for (const t of e.data)
            yield [t];
        else
          for (const t of $(e.data, p))
            yield t;
      }
      let U = 0;
      for (const [t, s] of se()) {
        const i = t[o] ?? U;
        J.push(i);
        let u = t[n];
        e.dataType === "tree" && (u = ((le = s.parent) == null ? void 0 : le[o]) ?? null);
        let K = _[u] || null;
        const m = E[u] || null, S = [], h = [], v = [];
        let y, w, k;
        m ? (y = m.childIds, w = m.children, k = m.childStats) : (y = B, w = z, k = V);
        const H = y.length, L = (m == null ? void 0 : m.level) + 1 || 1, F = {
          _isStat: !0,
          id: i,
          pid: u,
          childIds: S,
          siblingIds: y,
          node: t,
          parent: K,
          parentStat: m,
          children: h,
          childStats: v,
          siblings: w,
          siblingStats: k,
          index: H,
          level: L,
          open: e.openIds ? D.has(i) : !0,
          checked: P.has(i),
          draggable: !1
        };
        E[i] = F, _[i] = t, y.push(i), w.push(t), k.push(F), U++;
      }
      for (const [t] of $(V, "childStats")) {
        let s = ((ae = e.canDrag) == null ? void 0 : ae.call(e, t)) ?? null;
        s === null && (s = t.parentStat ? t.parentStat.draggable : !0), t.draggable = s;
      }
      return {
        // root
        rootIds: B,
        rootNodes: z,
        rootStats: V,
        // 
        allIds: J,
        // methods
        getStat: (t) => {
          let s;
          return typeof t == "object" ? s = t._isStat ? t.id : t[o] : s = t, E[s];
        }
      };
    },
    [
      e.data,
      e.dataType,
      o,
      n,
      D,
      P,
      I && e.canDrag
    ]
  ), { rootIds: N, rootStats: R, getStat: a } = O, x = e.indent, [f, T] = fe(), [M, A] = fe(), X = Se(null), Y = Se(null), [b, ee] = fe(), re = !f, ke = j(
    () => {
      const E = [], _ = [];
      for (const [t, { skipChildren: s }] of $(R, "childStats")) {
        const i = B(t);
        t === f && (Object.assign(i.style, {
          position: "fixed",
          top: 0,
          left: 0,
          pointerEvents: "none",
          zIndex: "-999999999",
          visibility: "hidden"
        }), i["data-dragging"] = !0), _.push(i), E.push(t.id), (!t.open || t === f) && s();
      }
      if (b) {
        const s = ((u, K) => {
          let m = ((u == null ? void 0 : u.childStats) || R)[K], S;
          if (m)
            S = E.indexOf(m.id);
          else {
            const h = (y) => y.siblingStats[y.siblingStats.indexOf(y) + 1];
            let v;
            if (u) {
              for (const y of ve(u, "parentStat", { withSelf: !0 }))
                if (v = h(y), v)
                  break;
            }
            v ? S = E.indexOf(v.id) : S = E.length;
          }
          return S;
        })(b.parentStat, b.index);
        E.splice(s, 0, g);
        const i = B({
          id: g,
          level: b.level
        }, !0);
        i["data-drag-placeholder"] = !0, _.splice(s, 0, i);
      }
      function B(t, s = !1) {
        return {
          key: t.id,
          draggable: t.draggable,
          style: { [`padding${d ? "Right" : "Left"}`]: (t.level - 1) * x + "px" },
          "data-key": t.id + "",
          "data-level": t.level + "",
          "data-node-box": !0,
          onDragStart(i) {
            var S;
            if (s) {
              i.preventDefault();
              return;
            }
            let u;
            const K = te.findParent(i.target, (h) => (!u && h.hasAttribute("draggable") && (u = h), h.hasAttribute("data-node-box")), { withSelf: !0 });
            if (K.querySelector("[draggable]") && u === K) {
              i.preventDefault();
              return;
            }
            if (i.dataTransfer.setData("text/plain", "he-tree he-tree-react"), i.dataTransfer.dropEffect = "move", e.customDragImage)
              e.customDragImage(i, t);
            else {
              const h = K.children[0];
              i.dataTransfer.setDragImage(h, d ? h.offsetWidth : 0, 0);
            }
            setTimeout(() => {
              var h;
              T(t), ee({
                ...b,
                parentStat: t.parentStat,
                level: t.level,
                index: (((h = t.parentStat) == null ? void 0 : h.childIds) || N).indexOf(t.id)
              });
            }, 0), (S = e.onDragStart) == null || S.call(e, i, t);
          },
          onDragLeave(i) {
          }
        };
      }
      const z = (t) => {
        var K, m, S;
        if (re && !((K = e.onExternalDragOver) != null && K.call(e, t)))
          return;
        const s = i();
        if (s) {
          const h = a(s.getAttribute("data-key")), v = !!s.getAttribute("data-drag-placeholder");
          u(h, v) && e.onDragOpen(h);
          let y = pe(h, v);
          const { closest: w, next: k } = y;
          let { atTop: H } = y;
          const L = Y.current, F = s;
          let Ie = (() => {
            let G = F.getBoundingClientRect(), W;
            return d ? W = Math.ceil((G.right - t.clientX) / x) : W = Math.ceil((t.clientX - G.x) / x), te.between(W, 0, ((w == null ? void 0 : w.level) || 0) + 1);
          })();
          if (!H && !v && w.id === N[0]) {
            const G = L.querySelector(`[data-key="${w.id}"]`);
            if (G) {
              const W = G.getBoundingClientRect();
              H = W.y + W.height / 2 > t.clientY;
            }
          }
          H && (Ie = 0);
          let de;
          if (H)
            U(null, 0) && (de = {
              ...b,
              parentStat: null,
              level: 1,
              index: 0
            });
          else {
            const G = k ? k.level - 1 : 0, W = [], De = [];
            let q = w;
            const ye = () => q ? q.level : 0;
            for (; ye() >= G; ) {
              const xe = le(q, k);
              if (U(q, xe) && (Ie > ye() ? W : De).unshift({
                parentStat: q,
                index: xe
              }), !q)
                break;
              q = q.parentStat;
            }
            let Q = te.arrayLast(W);
            Q || (Q = te.arrayFirst(De)), Q && (de = {
              ...b,
              parentStat: Q.parentStat,
              level: (((m = Q.parentStat) == null ? void 0 : m.level) ?? 0) + 1,
              index: Q.index
            });
          }
          ee(de), de && t.preventDefault(), A(v ? void 0 : h), (S = e.onDragOver) == null || S.call(e, t, h, re);
        } else
          U(null, 0) && (ee({
            ...b,
            parentStat: null,
            level: 1,
            index: 0
          }), t.preventDefault());
        function i() {
          const v = Y.current.querySelectorAll("[data-node-box]:not([data-dragging])"), y = te.binarySearch(
            // @ts-ignore
            v,
            (k) => k.getBoundingClientRect().top - t.clientY,
            { returnNearestIfNoHit: !0 }
          );
          let w;
          return y.hit || y.greater && (w = y.index - 1, w < 0 && (w = 0)), w == null && (w = y.index), v[w];
        }
        function u(h, v) {
          if (!e.dragOpen || v || h.open)
            return !1;
          const y = () => Object.assign(ne, { id: h.id, x: t.clientX, y: t.clientY, time: Date.now() });
          if (ne.id !== h.id || Le(t.clientX, t.clientY, ne.x, ne.y) > 10)
            return y(), !1;
          if (Date.now() - ne.time >= e.dragOpenDelay)
            return !0;
        }
      }, V = (t) => {
        var s, i;
        if (!(re && !((s = e.onExternalDragOver) != null && s.call(e, t))) && b && (t.preventDefault(), re)) {
          const { index: u } = b;
          (i = e.onExternalDrop) == null || i.call(e, t, b.parentStat, u), se();
        }
      };
      function J(t) {
        var u, K;
        if (!f)
          return;
        let s = !b;
        if (!s) {
          let S = Y.current.getBoundingClientRect();
          s = !(t.clientX >= S.left && t.clientX <= S.right && t.clientY >= S.top && t.clientY <= S.bottom);
        }
        if (!(((u = e.onDragEnd) == null ? void 0 : u.call(e, t, f, s)) === !1) && b) {
          let m = b.index;
          b.parentStat === f.parentStat && f.index < m && m--;
          const S = [...e.data];
          if (e.dataType === "flat") {
            const h = ((K = b.parentStat) == null ? void 0 : K.id) ?? e.rootId, v = Ae(S, f.id, c), y = { ...f.node, [n]: h };
            v[0] = y;
            const w = be(S, h, m, c);
            S.splice(w, 0, ...v);
          } else {
            const h = /* @__PURE__ */ new Map(), v = (k) => {
              if (!k)
                return S;
              const H = v(k.parentStat);
              let L = [...k.children];
              const F = h.get(k.node) || { ...k.node, [p]: L };
              return h.set(k.node, F), L = F[p], H[k.index] = F, L;
            }, y = v(f.parentStat), w = b.parentStat === f.parentStat ? y : v(b.parentStat);
            y.splice(f.index, 1), w.splice(m, 0, f.node);
          }
          e.onChange(S);
        }
        se();
      }
      function se() {
        A(void 0), T(void 0), ee(void 0);
      }
      function U(t, s) {
        var u, K;
        if (!t)
          return ((u = e.canDropToRoot) == null ? void 0 : u.call(e, s)) ?? !0;
        if (!t.open)
          return !1;
        let i = (K = e.canDrop) == null ? void 0 : K.call(e, t, s);
        return i == null && (i = U(t.parentStat)), i;
      }
      function pe(t, s) {
        let i = t, u = E.indexOf(s ? e.placeholderId : t.id), K = !1;
        const m = (k) => k === g || a(k) === f, S = (k, H) => {
          let L = k, F;
          do
            L += H, F = E[L];
          while (F && m(F));
          return { id: F, i: L };
        }, h = (k, H) => {
          const L = S(k, H);
          i = a(L.id), u = L.i;
        }, v = 1;
        s && (h(u, -1), i || (K = !0, h(-1, v)));
        const w = a(S(u, v).id);
        return { closest: i, atTop: K, next: w };
      }
      function le(t, s) {
        const i = t ? t.childStats : R;
        let u = i.length;
        return s && s.siblingStats === i && (u = i.indexOf(s)), u;
      }
      function ae(t, s = "start") {
        const i = a(t);
        if (!i)
          return !1;
        let u = E.indexOf(i.id);
        return u === -1 ? !1 : X.current ? (X.current.scrollToIndex(u, s), !0) : !1;
      }
      return { visibleIds: E, attrsList: _, onDragOverRoot: z, onDropToRoot: V, onDragEndOnRoot: J, scrollToNode: ae };
    },
    [
      O,
      x,
      f,
      // watch placeholder position
      b == null ? void 0 : b.parentStat,
      b == null ? void 0 : b.index,
      // watch props
      x,
      g,
      d,
      e.rootId,
      // watch func
      ...[e.canDrop, e.canDropToRoot, e.customDragImage, e.onDragStart, e.onDragOver, e.onExternalDragOver, e.onExternalDrop, e.onDragEnd, e.onChange, e.onDragOpen].map((E) => I && E)
    ]
  ), ue = j(() => ({
    getEl: () => window,
    onDragOverWindow: (E) => {
      _() || (A(void 0), e.keepPlaceholder || ee(void 0));
      function _() {
        let B = !1, z = E.target;
        if (z) {
          for (const V of ve(z, "parentElement", { withSelf: !0 }))
            if (V === Y.current) {
              B = !0;
              break;
            }
        }
        return B;
      }
    }
  }), [e.keepPlaceholder]);
  Be(ue.getEl, "dragover", ue.onDragOverWindow);
  const { visibleIds: ie, attrsList: he, onDragOverRoot: Te, onDropToRoot: Ee, onDragEndOnRoot: me, scrollToNode: Ce } = ke, Oe = j(() => f ? [ie.indexOf(f.id)] : [], [f, ie]), ge = (E) => {
    let _ = e.renderNodeBox;
    if (!_) {
      const B = /* @__PURE__ */ ce("div", { className: "he-tree-drag-placeholder", style: { minHeight: "20px", border: "1px dashed blue" } });
      _ = ({ stat: z, attrs: V, isPlaceholder: J }) => /* @__PURE__ */ Re("div", { ...V, key: V.key }, J ? B : e.renderNode(z));
    }
    return /* @__PURE__ */ ce("div", { className: `he-tree ${(E == null ? void 0 : E.className) || ""}`, style: E == null ? void 0 : E.style, ref: Y, onDragOver: Te, onDrop: Ee, onDragEnd: me, children: /* @__PURE__ */ ce(
      Ke,
      {
        ref: X,
        items: ie,
        virtual: e.virtual,
        persistentIndices: Oe,
        style: { height: "100%" },
        renderItem: (B, z) => _({
          stat: a(B),
          attrs: he[z],
          isPlaceholder: B === g
        })
      }
    ) });
  };
  return {
    ...O,
    // 
    visibleIds: ie,
    attrsList: he,
    // ref
    virtualListRef: X,
    // drag states
    draggingStat: f,
    dragOverStat: M,
    placeholder: b,
    // render
    renderTree: ge,
    renderHeTree: ge,
    // methods
    scrollToNode: Ce
  };
}
function Ve(r, e, o = "children") {
  for (const n of $(r, o))
    e(...n);
}
function* $(r, e = "children") {
  let o = !1, n = !1;
  const p = () => {
    o = !0;
  }, g = () => {
    n = !0;
  };
  yield* I(r, null, []);
  function* I(c, d, l) {
    let D = 0;
    for (const C of c) {
      if (yield [C, { parent: d, parents: l, siblings: c, index: D, skipChildren: p, exitWalk: g }], n)
        return;
      if (D++, o)
        o = !1;
      else {
        const O = C[e];
        if (O && (yield* I(O, C, [...l, C]), n))
          return;
      }
    }
  }
}
function Xe(r, e, o = "children") {
  for (const n of $(r, o))
    if (e(...n))
      return n[0];
}
function We(r, e, o = "children") {
  const n = [];
  for (const p of $(r, o))
    e(...p) && n.push(p[0]);
  return n;
}
function* ve(r, e, o = { withSelf: !1 }) {
  let n = r;
  for (; n; )
    (n !== r || o.withSelf) && (yield n), n = typeof e == "function" ? e(n) : n[e];
}
function Ye(r, e) {
  const o = { ...Z, ...e }, { idKey: n, parentIdKey: p } = o, g = /* @__PURE__ */ new Map();
  g.set(null, []);
  const I = g.get(null);
  for (const d of r) {
    const l = d[n];
    g.set(l, []);
  }
  for (const d of r) {
    const l = d[p];
    (g.get(l) || I).push(d);
  }
  function* c(d) {
    for (const l of d) {
      yield l;
      const D = l[n];
      yield* c(g.get(D));
    }
  }
  return [...c(I)];
}
const Z = {
  idKey: "id",
  parentIdKey: "parent_id"
};
function* oe(r, e) {
  const o = { ...Z, ...e }, { idKey: n, parentIdKey: p } = o;
  let g = !1, I = !1;
  const c = () => {
    g = !0;
  }, d = () => {
    I = !0;
  }, l = {}, D = {}, C = {}, P = [];
  let O, N = 0;
  for (const R of r) {
    const a = R[n], x = R[p] ?? null;
    l[a] = R;
    const f = l[x] || null;
    C[a] = [];
    const T = f ? C[x] : P, M = T.length;
    T.push(a);
    const A = {
      parent: f,
      parents: f ? [...D[x].parents, f] : [],
      index: M,
      id: a,
      pid: x,
      treeIndex: N,
      skipChildren: c,
      exitWalk: d
    };
    D[a] = A;
    let X = !1;
    if (g && O && (O.has(x) ? (O.add(a), X = !0) : (g = !1, O = void 0)), !X) {
      if (yield [R, A], I)
        break;
      g && (O = /* @__PURE__ */ new Set([a]));
    }
    N++;
  }
}
function qe(r, e, o) {
  for (const n of oe(r, o))
    e(...n);
}
function be(r, e, o, n) {
  const p = { ...Z, ...n }, { idKey: g, parentIdKey: I } = p;
  let c = !1, d = -1;
  for (const [l, { treeIndex: D, skipChildren: C, index: P }] of oe(r, p))
    if (e != null && !c)
      l[g] === e && (c = !0);
    else if (e == null || l[I] === e)
      if (o != null && o === P) {
        d = D;
        break;
      } else
        C();
    else {
      d = D;
      break;
    }
  return d === -1 && (d = r.length), d;
}
function je(r, e, o, n) {
  const p = { ...Z, ...n }, { idKey: g, parentIdKey: I } = p, c = e[I] ?? null, d = be(r, c, o, p);
  r.splice(d, 0, e);
}
function Ae(r, e, o) {
  if (e == null)
    return r.splice(0, r.length);
  const n = { ...Z, ...o }, { idKey: p, parentIdKey: g } = n;
  let I = -1, c = -1;
  for (const [d, { treeIndex: l, skipChildren: D }] of oe(r, n))
    if (I === -1)
      d[p] === e && (I = l, D());
    else {
      c = l;
      break;
    }
  return c === -1 && (c = r.length), I === -1 ? [] : r.splice(I, c - I);
}
function $e(r, e, o, n) {
  const p = { ...Z, ...n }, { idKey: g, parentIdKey: I } = p, c = new Set(e), d = Array.isArray(o) ? o : [o], l = new Set(d);
  if (l.size > 0)
    for (const [D, { parents: C }] of oe(r, p)) {
      const P = D[g];
      if (l.has(P)) {
        for (const O of C)
          c.add(O[g]);
        if (l.delete(P), l.size === 0)
          break;
      }
    }
  return Array.from(c).sort();
}
const we = {
  idKey: "id",
  childrenKey: "children"
};
function Ue(r, e, o, n) {
  const p = { ...we, ...n }, { idKey: g, childrenKey: I } = p, c = new Set(e), d = Array.isArray(o) ? o : [o], l = new Set(d);
  if (l.size > 0)
    for (const [D, { parents: C }] of $(r, p.childrenKey)) {
      const P = D[g];
      if (l.has(P)) {
        for (const O of C)
          c.add(O[g]);
        if (l.delete(P), l.size === 0)
          break;
      }
    }
  return Array.from(c).sort();
}
function Ge(r, e, o, n, p) {
  const g = new Set(e), I = Array.isArray(o) ? o : [o], c = /* @__PURE__ */ new Map(), d = new Set(I), l = /* @__PURE__ */ new Map(), D = [];
  l.set(null, D);
  for (const [N, { parents: R, id: a, pid: x }] of oe(r, p))
    l.get(x).push(a), l.set(a, []), c.set(a, g.has(a)), (d.has(a) || x && d.has(x)) && (c.set(a, n), d.add(a));
  const C = (N) => {
    const R = l.get(N);
    if (!R || R.length === 0)
      return c.get(N);
    let a = !1, x = !1, f = !1;
    for (const M of R) {
      let A = C(M);
      A === !1 ? x = !0 : A === null ? f = !0 : a = !0;
    }
    let T;
    return f || x && a ? T = null : x ? T = !1 : T = !0, c.set(N, T), T;
  };
  for (const N of D)
    C(N);
  const P = [], O = [];
  return c.forEach((N, R) => {
    N === !0 ? P.push(R) : N === null && O.push(R);
  }), [P.sort(), O.sort()];
}
function Je(r, e, o, n, p) {
  const g = { ...we, ...p }, { idKey: I, childrenKey: c } = g, d = new Set(e), l = Array.isArray(o) ? o : [o], D = /* @__PURE__ */ new Map(), C = new Set(l), P = /* @__PURE__ */ new Map();
  P.set(null, []);
  for (const [a, { parents: x, parent: f }] of $(r, c)) {
    const T = a[I], M = (f == null ? void 0 : f[I]) ?? null;
    P.get(M).push(T), P.set(T, []), D.set(T, d.has(T)), (C.has(T) || M && C.has(M)) && (D.set(T, n), C.add(T));
  }
  const O = (a) => {
    const x = P.get(a);
    if (!x || x.length === 0)
      return D.get(a);
    let f = !1, T = !1, M = !1;
    for (const X of x) {
      let Y = O(X);
      Y === !1 ? T = !0 : Y === null ? M = !0 : f = !0;
    }
    let A;
    return M || T && f ? A = null : T ? A = !1 : A = !0, D.set(a, A), A;
  };
  for (const a of r)
    O(a[I]);
  const N = [], R = [];
  return D.forEach((a, x) => {
    a === !0 ? N.push(x) : a === null && R.push(x);
  }), [N.sort(), R.sort()];
}
function Le(r, e, o, n) {
  return Math.sqrt(Math.pow(o - r, 2) + Math.pow(n - e, 2));
}
function Be(r, e, o) {
  Pe(() => {
    const n = r();
    return n == null || n.addEventListener(e, o), () => {
      n == null || n.removeEventListener(e, o);
    };
  }, [r, e, o]);
}
export {
  je as addToFlatData,
  be as convertIndexToTreeIndexInFlatData,
  Ne as defaultProps,
  We as filterTreeData,
  Xe as findTreeData,
  $e as openParentsInFlatData,
  Ue as openParentsInTreeData,
  Ae as removeByIdInFlatData,
  Ye as sortFlatData,
  Ge as updateCheckedInFlatData,
  Je as updateCheckedInTreeData,
  ze as useHeTree,
  qe as walkFlatData,
  oe as walkFlatDataGenerator,
  ve as walkParentsGenerator,
  Ve as walkTreeData,
  $ as walkTreeDataGenerator
};
